"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
exports.laravel = void 0;
var code_builder_1 = require("../../../../helpers/code-builder");
exports.laravel = {
    info: {
        key: 'laravel',
        title: 'Laravel',
        link: 'https://laravel.com/',
        description: 'ReadMe Metrics Webhooks SDK usage on Laravel'
    },
    convert: function (_a, options) {
        var secret = _a.secret, security = _a.security, server = _a.server;
        var opts = __assign({ indent: '    ' }, options);
        var _b = new code_builder_1.CodeBuilder({ indent: opts.indent }), blank = _b.blank, join = _b.join, push = _b.push, ranges = _b.ranges, variable = _b.variable;
        push('<?php');
        blank();
        push('// Your ReadMe secret');
        push("$secret = '".concat(secret, "';"));
        blank();
        push('// Add this code into your `routes/web.php` file.');
        push("Route::post('/webhook', function (\\Illuminate\\Http\\Request $request) use ($secret) {");
        push('// Verify the request is legitimate and came from ReadMe.', 1);
        push("$signature = $request->headers->get('readme-signature', '');", 1);
        blank();
        push('try {', 1);
        push('\\ReadMe\\Webhooks::verify($request->input(), $signature, $secret);', 2);
        push('} catch (\\Exception $e) {', 1);
        push('// Handle invalid requests', 2);
        push('return response()->json([', 2);
        push("'error' => $e->getMessage()", 3);
        push('], 401);', 2);
        push('}', 1);
        blank();
        push('// Fetch the user from the database and return their data for use with OpenAPI variables.', 1);
        push("// $user = DB::table('users')->where('email', $request->input('email'))->limit(1)->get();", 1);
        push('return response()->json([', 1);
        if (server.length) {
            push('// OAS Server variables', 2);
            server.forEach(function (data) {
                push("'".concat(data.name, "' => '").concat(data["default"] || data["default"] === '' ? data["default"] : data.name, "',"), 2);
                variable('server', data.name);
            });
        }
        if (server.length && security.length) {
            blank();
        }
        if (security.length) {
            push('// OAS Security variables', 2);
            security.forEach(function (data) {
                if (data.type === 'http') {
                    // Only HTTP Basic auth has any special handling for supplying auth.
                    if (data.scheme === 'basic') {
                        push("'".concat(data.name, "' => ['user' => 'user', 'pass' => 'pass'],"), 2);
                        variable('security', data.name);
                        return;
                    }
                }
                push("'".concat(data.name, "' => '").concat(data["default"] || data["default"] === '' ? data["default"] : data.name, "',"), 2);
                variable('security', data.name);
            });
        }
        push(']);', 1);
        push('});');
        return {
            ranges: ranges(),
            snippet: join()
        };
    }
};
